# --------------------------------------------------- #
# Script of Saga III Item.cgi Version 1 (2.0)
# Copyright (C) 2007 Missing Link.
# --------------------------------------------------- #

# Sub Get Item Data #
sub get_item_data {
my  $Si = shift;
my  $K;

    return 0 unless exists $FD{$Si->{id}};

    $K = $Si->{id};
    $K = $FD{$K}{tp} if $FD{$K}{tp};
    $Si->{qn} ||= 1;
    $Si->{bp} = $FD{$K}{bp};
    $Si->{wt} = $FD{$K}{wt};
    $Si->{wt} = 0.1 if !$Si->{wt};
    $Si->{ef} = &set_nutrition($FD{$K}) if $Si->{cl} eq 'Fd';
    return 1;
}

# Sub Set Item Data #
sub set_item_data {
my  $Si = shift;

    &get_item_data($Si) && return;

    $Si->{bp} = &divide_by_quantity($Si,'bp');
    $Si->{wt} = &divide_by_quantity($Si,'wt');
    $Si->{wt} = 0.1 if $Si->{wt} <= 0 || $Si->{cl} eq 'Cn';
    $Si->{ef} = &set_nutrition($Si,1) if $Si->{cl} eq 'Fd';
}

# Sub Set Nutrition #
sub set_nutrition {
my  $Si = shift;
my  $F  = shift; # divide it or not
my  ($K,@V);

    return $Si->{ef} if $Si->{ef};

    foreach $K ('lf','hl','hy') {
        &divide_by_quantity($Si,$K) if $F;
        push(@V,"$K=$Si->{$K}") if $Si->{$K};
    }
    return join(',',@V);
}

# Sub Divide by Quantity #
sub divide_by_quantity {
my  $Si = shift;
my  $K  = shift; # initial

    return if !$Si->{$K};
    return $Si->{$K} if $Si->{qn} <= 1;
    $Si->{$K} *= 10 if $K eq 'wt';
    $Si->{$K}  = int($Si->{$K} / $Si->{qn} + 0.5);
    $Si->{$K} /= 10 if $K eq 'wt';
    return $Si->{$K};
}

# Sub Get Quality #
sub get_quality {
my  $Si = shift;

    map { $Si->{Ql}{$_} = 1 } split(/,/,$Si->{ql});
}

# --------------------------------------------------- #
1;
